'Compilable Example:
#Compile Exe  "gbworldclock.exe"
#Dim All
#Include "Win32API.inc"
#Resource Icon aaa "icons\gbworldclock.ico"

Enum MyEquates Singular
   IDC_Label = 500
   IDC_Timer
   IDC_TimerD
   IDM_Help
   IDM_Exit
   IDM_Sep
   IDM_Transparency
   IDM_LookupSite
   IDM_EditLocations
   IDM_TextColor
   IDM_Gripper
   IDM_SortNone
   IDM_SortTitleA
   IDM_SortGMTA
   IDM_SortTitleD
   IDM_SortGMTD
   IDM_Military
   IDM_RefreshNow
   IDM_BGColor
   IDM_ShowIcons
   IDM_SelectOpaqueFont
   IDM_SelectTransparencyFont
   IDM_TimeInCaption
   IDM_DefaultFonts
   IDM_About
   IDM_AutoDock
   IDM_SizeToFitNow
   IDM_AutoFit
End Enum

%SortNone   = 0
%SortTitleA = 1
%SortGMTA   = 2
%SortTitleD = 3
%SortGMTD   = 4

Type Locations
   title As StringZ * 50
   gmt As Single
   img As StringZ * 50
   url As StringZ * 260
End Type

Type CustomColors
   c(15) As Long
End Type

$Ver = "gbWorldClock   v1.21"
$LocationFile = "locations.txt"
%OffWhite = 16448250

Global hDlg,hDC,hPopup,hIcon,pid,hFont,ghHook As Dword, LookupSite, OpaqueFontName, TransparencyFontName As String
Global Transparency, TextColor, Gripper, Military, AutoDock, Docked, AutoFit, LineHeight  As Long
Global Restart, BGColor, ShowIcons, FontSize, FontStyle, TimeInCaption, SortMode, MaxTitle As Long
Global tempz, INIFileName As AsciiZ * %Max_Path, D() As Locations, CustomColorList As CustomColors
Global G1,G2,G3,G4 As Long
Global xPreRollup, yPreRollup, wPrerollup, hPreRollup As Long
Global mDock, wDock, deskW, deskH, xDock, yDock As Long

Function PBMain() As Long
   INIFileName = Exe.Path$ + "gbworldclock.ini"
   Getprivateprofilestring "All", "Transparency", "0", tempz, %Max_Path, INIFileName:  Transparency = Val(tempz)

   If Transparency Then
      Dialog New Pixels, 0, $Ver,300,300,310,360, %WS_Popup, %WS_Ex_Layered To hDlg
      Dialog Set Color hDlg, %OffWhite,%OffWhite
   Else
      Dialog New Pixels, 0, $Ver,300,300,310,360, %WS_OverlappedWindow To hDlg
   End If

   Dialog Set Icon hDlg, "aaa"
   Dialog Show Modal hDlg Call DlgProc
   If Restart Then pid = Shell(Exe.Full$,1)  'restart this app
End Function

CallBack Function DlgProc() As Long
   Local PS As PaintStruct, GMT As Long, temp$, i,x,y As Long, PR As Rect, hWnd As Dword
   Select Case Cb.Msg
      Case %WM_InitDialog
         G1 = 5 : G2 = 5 : G3 = 10 : G4 = 5
         mDock = 20 : wDock = 270
         Settings_INI "get"
         If Docked Then SetTimer(hDlg,%IDC_TimerD,250,ByVal %Null)
         hFont = MakeFont(IIf$(Transparency, TransparencyFontName, OpaqueFontName), FontSize, FontStyle)
         If TimeInCaption Then Dialog Set Text hDlg, $Ver + Space$(6) + CurrentTime
         LoadLocations
         SizeToFitData 0   'AutoFit
         SortLocationList
         If Transparency = 0 Then Dialog Set Color hDlg, BGColor, BGColor
         SetTimer(hDlg, %IDC_Timer, 60000&, %NULL)    'sends %WM_Timer to dialog callback
         CreatePopup
         SetMenuStatus
         If Transparency Then SetLayeredWindowAttributes(hDlg, %OffWhite, 255, %LWA_ALPHA Or %LWA_ColorKey)
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_RefreshNow
'               For i = 0 to ubound(D) : temp$ = temp$ + Str$(i) + D(i).URL + $crlf : NExt i : ? temp$
               Dialog ReDraw hDlg
            Case %IDM_About
               temp$ = $CrLf + $CrLf + "Opaque Font Name: " + OpaqueFontName
               temp$ = temp$ + $CrLf + "Transparency Font Name: " + TransparencyFontName
               temp$ = temp$ + $CrLf + "Font Size: " + Str$(FontSize)
               MsgBox $Ver + temp$, %MB_Ok + %MB_IconInformation, "About"
            Case %IDM_Exit
               Dialog End hDlg
            Case %IDM_SortNone
               SortMode = %SortNone
               SetMenuStatus
               SortLocationList
            Case %IDM_SortTitleA
               SortMode = %SortTitleA
               SetMenuStatus
               SortLocationList
            Case %IDM_SortGMTA
               SortMode = %SortGMTA
               SetMenuStatus
               SortLocationList
            Case %IDM_SortTitleD
               SortMode = %SortTitleD
               SetMenuStatus
               SortLocationList
            Case %IDM_SortGMTD
               SortMode = %SortGMTD
               SetMenuStatus
               SortLocationList
            Case %IDM_Military
               Military = Military Xor 1
               If TimeInCaption Then Dialog Set Text hDlg, $Ver + Space$(6) + CurrentTime
               SetMenuStatus
               SizeToFitData AutoFit
               Dialog ReDraw hDlg
            Case %IDM_AutoDock
               AutoDock = AutoDock Xor 1
               SetMenuStatus
            Case %IDM_AutoFit
               AutoFit = AutoFit Xor 1
               SetMenuStatus
               SizeToFitData AutoFit
            Case %IDM_TimeInCaption
               TimeInCaption = TimeInCaption Xor 1
               SetDialogCaption
               SetMenuStatus
            Case %IDM_ShowIcons
               ShowIcons = ShowIcons Xor 1
               SetMenuStatus
               SizeToFitData AutoFit
               Dialog ReDraw hDlg
            Case %IDM_SizeToFitNow
               SizeToFitData 1
            Case %IDM_DefaultFonts
               OpaqueFontName = "Consolas"
               TransparencyFontName = "System"
               FontSize = 10
               FontStyle = 1
               hFont = MakeFont(IIf$(Transparency, TransparencyFontName, OpaqueFontName), FontSize, FontStyle)
               SizeToFitData AutoFit
               Dialog ReDraw hDlg
            Case %IDM_SelectOpaqueFont
               SelectOpaqueFont
               hFont = MakeFont(OpaqueFontName, FontSize, FontStyle)
               SizeToFitData AutoFit
               Dialog ReDraw hDlg
            Case %IDM_SelectTransparencyFont
               SelectTransparencyFont
               hFont = MakeFont(TransparencyFontName, FontSize, FontStyle)
               SizeToFitData AutoFit
               Dialog ReDraw hDlg
            Case %IDM_Transparency
               Transparency = Transparency Xor 1
               SetDialogBGColor
               SetMenuStatus
               SizeToFitData AutoFit
               Restart = 1
               Dialog End hDlg
            Case %IDM_Gripper
               Gripper = Gripper Xor 1
               SetMenuStatus
               Dialog ReDraw hDlg
            Case %IDM_EditLocations
               Dialog Show State hDlg, %SW_Minimize
               Shell ("Notepad " + Exe.Path$ + $LocationFile, 1)  'opens Notepad, waits for it to close
               LoadLocations
               Dialog Show State hDlg, %SW_Restore
               Dialog ReDraw hDlg
            Case %IDM_TextColor
               Display Color hDlg, 100, 100, TextColor, CustomColorList , 0 To i   'i has selected color
               If i <> -1 Then TextColor = i : Dialog ReDraw hDlg
            Case %IDM_BGColor
               Display Color hDlg, 100, 100, BGColor, CustomColorList ,0 To i   'i has selected color
               If i <> -1 Then BGColor = i : Dialog ReDraw hDlg
               SetDialogBGColor
               Dialog ReDraw hDlg
            Case %IDM_LookupSite
               temp$ = "http://www.timeanddate.com/worldclock/"
               ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_Help
               temp$ = "http://www.garybeene.com/sw/gbworldclock.htm"
               ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
         End Select
      Case %WM_LButtonDblClk
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         Select Case y
            Case <= (UBound(D)+1) * (LineHeight+g4)
               temp$ = D(y/(LineHeight+g4)).URL
               If Len(Trim$(temp$)) Then
                  ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               Else
                  Beep
               End If
            Case Else : Dialog End hDlg
         End Select
      Case %WM_NCLButtonDblClk
          RollUpWindowAndDock
          Function = 1 : Exit Function
      Case %WM_ContextMenu
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hPopup, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 1 : Exit Function
      Case %WM_LButtonDown
         If Cb.WParam = %MK_LBUTTON Then SendMessage hDlg, %WM_NCLButtonDown, %HTCaption, ByVal %Null  ' force drag
      Case %WM_Timer
         If Cb.Ctl = %IDC_Timer Then
            'update every minute timer
            SetDialogCaption
            Dialog ReDraw hDlg
         Else
            'watch for Taskbar position change timer
            hWnd = FindWindow("Shell_TrayWnd","")
            GetWindowRect hWnd, pr
            Desktop Get Size To deskW, deskH
            Dialog Get Loc hDlg To x,y
            If (x=xDock And y=yDock) Then
               xDock = deskW-wDock-mDock
               yDock = pr.nTop-2*mDock
               Dialog Set Loc hDlg, xDock,yDock
            End If
         End If
      Case %WM_Destroy
         KilLTimer hDlg, %IDC_Timer
         KilLTimer hDlg, %IDC_TimerD
         Settings_INI "save"
      Case %WM_Paint
         'margin diagram
         '             g4
         '   | g1 -----16------ g2 -----MaxTitle----- g3 ----TimeString----- g1
         '             g4
         '   | g1 -----16------ g2 -----MaxTitle----- g3 ----TimeString----- g1
         '             g4
         hDC = BeginPaint(hDlg, PS)
         hFont = SelectObject(hDC,hFont)
         SetBkMode hDC, %Transparent
         SetTextColor hDC, TextColor

         For i = 0 To UBound(D)
            'draw icons
            If ShowICons Then
               hIcon = LoadImage(%Null, Exe.Path$ + "flags\" + D(i).img, %Image_Icon, 16,16, %LR_LoadFromFile)
               drawiconex hDC, g1, i*(LineHeight+g4) + (LineHeight-16)/2, hIcon, 16,16,0,%Null, %DI_Normal
            End If
            'draw text
            x = g1+ShowIcons*(16+g2)  :  y = i*(LineHeight+g4)
            textout hDC, x,y,(D(i).title),Len(D(i).title)
            x = x + (MaxTitle+g3)
            textout hDC, x,y,(TimeString(D(i).gmt)),Len(TimeString(D(i).gmt))
         Next i

         'Gripper
         If Transparency And Gripper Then
            PR.nTop  = (UBound(D)+1)*(LineHeight+g4)
            If ShowIcons Then PR.nLeft = g1 Else PR.nLeft = g1
            PR.nLeft = g1
            PR.nRight = PR.nLeft + 10 : PR.nBottom = PR.nTop + 10
            FillRect hDC, PR, GetStockObject(%Black_Brush)
         End If
         'shut down
         hFont = SelectObject(hDC,hFont)
         EndPaint hDlg, PS
   End Select
End Function

Function TimeString(Delta As Single) As String
   Local TS As IPowerTime
   Let   TS = Class "PowerTime"
   TS.NowUTC        'assign current UTC time
   TS.AddHours Fix(Delta)
   TS.AddMinutes Frac(Delta)*60
   If Military Then
      Function = TS.TimeString24 + "  " + Left$(TS.DayOfWeekString,3)
   Else
      Function = TS.TimeString + "  " + Left$(TS.DayOfWeekString,3)
   End If
End Function

Sub Settings_INI(Task$)
   Local i,x,y As Long, xResult, yResult As AsciiZ * %Max_Path
   'set ini filename
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "308", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "167", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "LookupSite", "http://www.garybeene.com/sw/gbcloud.htm", tempz, %Max_Path, INIFileName : LookupSite = tempz
      Getprivateprofilestring "All", "OpaqueFontName", "Consolas", tempz, %Max_Path, INIFileName : OpaqueFontName = tempz
      Getprivateprofilestring "All", "TransparencyFontName", "System", tempz, %Max_Path, INIFileName : TransparencyFontName = tempz

      'get value for numeric variables
      Getprivateprofilestring "All", "xDock", "308", tempz, %Max_Path, INIFileName:  xDock = Val(tempz)
      Getprivateprofilestring "All", "yDock", "167", tempz, %Max_Path, INIFileName:  yDock = Val(tempz)
      Getprivateprofilestring "All", "Docked", "0", tempz, %Max_Path, INIFileName:  Docked = Val(tempz)
      Getprivateprofilestring "All", "xPreRollup", "0", tempz, %Max_Path, INIFileName:  xPreRollup = Val(tempz)
      Getprivateprofilestring "All", "yPreRollup", "0", tempz, %Max_Path, INIFileName:  yPreRollup = Val(tempz)
      Getprivateprofilestring "All", "wPreRollup", "0", tempz, %Max_Path, INIFileName:  wPreRollup = Val(tempz)
      Getprivateprofilestring "All", "hPreRollup", "0", tempz, %Max_Path, INIFileName:  hPreRollup = Val(tempz)
      Getprivateprofilestring "All", "LineHeight", "20", tempz, %Max_Path, INIFileName:  LineHeight = Val(tempz)
      Getprivateprofilestring "All", "SortMode", "2", tempz, %Max_Path, INIFileName:  SortMode = Val(tempz)
      Getprivateprofilestring "All", "AutoFit", "1", tempz, %Max_Path, INIFileName:  AutoFit = Val(tempz)
      Getprivateprofilestring "All", "AutoDock", "1", tempz, %Max_Path, INIFileName:  AutoDock = Val(tempz)
      Getprivateprofilestring "All", "TimeInCaption", "0", tempz, %Max_Path, INIFileName:  TimeInCaption = Val(tempz)
      Getprivateprofilestring "All", "ShowIcons", "1", tempz, %Max_Path, INIFileName:  ShowIcons = Val(tempz)
      Getprivateprofilestring "All", "BGColor", Str$(%rgb_NavajoWhite), tempz, %Max_Path, INIFileName:  BGColor = Val(tempz)
      Getprivateprofilestring "All", "Military", "0", tempz, %Max_Path, INIFileName:  Military = Val(tempz)
      Getprivateprofilestring "All", "Transparency", "0", tempz, %Max_Path, INIFileName:  Transparency = Val(tempz)
      Getprivateprofilestring "All", "Gripper", "0", tempz, %Max_Path, INIFileName:  Gripper = Val(tempz)
      Getprivateprofilestring "All", "TextColor", "0", tempz, %Max_Path, INIFileName:  TextColor = Val(tempz)
      Getprivateprofilestring "All", "FontSize", "10", tempz, %Max_Path, INIFileName:  FontSize = Val(tempz)
      Getprivateprofilestring "All", "FontStyle", "1", tempz, %Max_Path, INIFileName:  FontStyle = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      Dialog Get Client hDlg To x,y
      'save string variables
      WritePrivateProfileString "All", "OpaqueFontName",(OpaqueFontName), INIFileName
      WritePrivateProfileString "All", "TransparencyFontName",(TransparencyFontName), INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "xDock", (Str$(xDock)), INIFileName
      WritePrivateProfileString "All", "yDock", (Str$(yDock)), INIFileName
      WritePrivateProfileString "All", "Docked", (Str$(Docked)), INIFileName
      WritePrivateProfileString "All", "xPreRollup", (Str$(xPreRollup)), INIFileName
      WritePrivateProfileString "All", "yPreRollup", (Str$(yPreRollup)), INIFileName
      WritePrivateProfileString "All", "wPreRollup", (Str$(wPreRollup)), INIFileName
      WritePrivateProfileString "All", "hPreRollup", (Str$(hPreRollup)), INIFileName
      WritePrivateProfileString "All", "LineHeight", (Str$(LineHeight)), INIFileName
      WritePrivateProfileString "All", "SortMode", (Str$(SortMode)), INIFileName
      WritePrivateProfileString "All", "AutoFit", (Str$(AutoFit)), INIFileName
      WritePrivateProfileString "All", "AutoDock", (Str$(AutoDock)), INIFileName
      WritePrivateProfileString "All", "TimeInCaption", (Str$(TimeInCaption)), INIFileName
      WritePrivateProfileString "All", "ShowIcons", (Str$(ShowIcons)), INIFileName
      WritePrivateProfileString "All", "BGColor", (Str$(BGColor)), INIFileName
      WritePrivateProfileString "All", "Military", (Str$(Military)), INIFileName
      WritePrivateProfileString "All", "Transparency", (Str$(Transparency)), INIFileName
      WritePrivateProfileString "All", "Gripper", (Str$(Gripper)), INIFileName
      WritePrivateProfileString "All", "TextColor", (Str$(TextColor)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontStyle", (Str$(FontStyle)), INIFileName
      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i
   End If
End Sub

Sub CreatePopup
    Menu New PopUp To hPopup
    Menu Add String, hPopup, "Online Location Search",    %IDM_LookupSite,  %MF_Enabled
    Menu Add String, hPopup, "Edit Location List",    %IDM_EditLocations,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Select Text Color",    %IDM_TextColor,  %MF_Enabled
    Menu Add String, hPopup, "Select Background Color",    %IDM_BGColor,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Select Opaque Font",    %IDM_SelectOpaqueFont,  %MF_Enabled
    Menu Add String, hPopup, "Select Transparency Font",    %IDM_SelectTransparencyFont,  %MF_Enabled
    Menu Add String, hPopup, "Restore Default Fonts",    %IDM_DefaultFonts,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Size To Fit Data Now",    %IDM_SizeToFitNow,  %MF_Enabled
    Menu Add String, hPopup, "Refresh Now",    %IDM_RefreshNow,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Sort None",    %IDM_SortNone,  %MF_Enabled
    Menu Add String, hPopup, "Sort By Time, Ascending",    %IDM_SortGMTA,  %MF_Enabled
    Menu Add String, hPopup, "Sort By Time, Descending",    %IDM_SortGMTD,  %MF_Enabled
    Menu Add String, hPopup, "Sort By Title, Ascending",    %IDM_SortTitleA,  %MF_Enabled
    Menu Add String, hPopup, "Sort By Title, Descending",    %IDM_SortTitleD,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Transparency",    %IDM_Transparency,  %MF_Enabled
    Menu Add String, hPopup, "Show Gripper",    %IDM_Gripper,  %MF_Enabled
    Menu Add String, hPopup, "24-Hr Time",    %IDM_Military,  %MF_Enabled
    Menu Add String, hPopup, "Show Icons",    %IDM_ShowIcons,  %MF_Enabled
    Menu Add String, hPopup, "Local Time",    %IDM_TimeInCaption,  %MF_Enabled
    Menu Add String, hPopup, "AutoDock To Tray",    %IDM_AutoDock,  %MF_Enabled
    Menu Add String, hPopup, "AutoSize",    %IDM_AutoFit,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "Online Help",    %IDM_Help,  %MF_Enabled
    Menu Add String, hPopup, "-",      %IDM_Sep,    %MF_Enabled
    Menu Add String, hPopup, "About",  %IDM_About,  %MF_Enabled
    Menu Add String, hPopup, "Exit",    %IDM_Exit,  %MF_Enabled
End Sub

Sub LoadLocations
   Local i,iCount As Long
   'load locations data into string array
   Open $LocationFile For Input As #1
   FileScan #1, Records To iCount        'get count of lines of text in the file
   Dim TempArray(iCount-1) As String     'Dim 0 to count-1
   ReDim D(iCount-1)
   Line Input #1, TempArray() To iCount  'Get entire array in one gulp, count& gives # lines read
   Close #1
   'extract info
   iCount = -1
   For i = 0 To UBound(TempArray)
      If Trim$(TempArray(i)) = "" Then Iterate For
      If Left$(TempArray(i),3) = "***" Then Exit For  'ignore rest of fle
      Incr iCount
      D(iCount).title = Trim$(Parse$(TempArray(i),":",1))
      D(iCount).gmt   = Val(Parse$(TempArray(i),":",2))
      D(iCount).img   = Trim$(Parse$(TempArray(i),":",3))
      D(iCount).url   = Trim$(Parse$(TempArray(i),":",4)) + ":" + Trim$(Parse$(TempArray(i),":",5))
      If D(iCount).url = ":" Then D(iCount).url = ""
   Next i
   ReDim Preserve D(iCount)
End Sub

Function SortByTitle(A As Locations, B As Locations) As Long
   If SortMode = %SortTitleA Then
       Select Case LCase$(A.title)
          Case < LCase$(B.title)  : Function = -1
          Case > LCase$(B.title)  : Function = +1
          Case = LCase$(B.title)  : Function = IIf(A.gmt < B.gmt, -1, +1)
       End Select
   Else
       Select Case LCase$(A.title)
          Case > LCase$(B.title)  : Function = -1
          Case < LCase$(B.title)  : Function = +1
          Case = LCase$(B.title)  : Function = IIf(A.gmt > B.gmt, -1, +1)
       End Select
   End If
End Function

Function SortByGMT(A As Locations, B As Locations) As Long
   If SortMode = %SortGMTA Then
       'ascending
       Select Case A.gmt
          Case < B.gmt  : Function = -1
          Case > B.gmt  : Function = +1
          Case = B.gmt  : Function = IIf(LCase$(A.title) < LCase$(B.title), -1, +1)
       End Select
   Else
       'descending
       Select Case A.gmt
          Case > B.gmt  : Function = -1
          Case < B.gmt  : Function = +1
          Case = B.gmt  : Function = IIf(LCase$(A.title) > LCase$(B.title), -1, +1)
       End Select
   End If
End Function

Sub SetMenuStatus
    Menu Set State hPopup, ByCmd %IDM_Transparency, Transparency * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_Gripper, Gripper * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_Military, Military * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_ShowIcons, ShowIcons * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_TimeInCaption, TimeInCaption * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_AutoDock, AutoDock * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopup, ByCmd %IDM_AutoFit, AutoFit * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopup, ByCmd %IDM_SortNone, 0
    Menu Set State hPopup, ByCmd %IDM_SortGMTA, 0
    Menu Set State hPopup, ByCmd %IDM_SortTitleA, 0
    Menu Set State hPopup, ByCmd %IDM_SortGMTD, 0
    Menu Set State hPopup, ByCmd %IDM_SortTitleD, 0
    Select Case SortMode
       Case %SortNone   : Menu Set State hPopup, ByCmd %IDM_SortNone, %MFS_Checked Or %MFS_Enabled
       Case %SortGMTA   : Menu Set State hPopup, ByCmd %IDM_SortGMTA, %MFS_Checked Or %MFS_Enabled
       Case %SortTitleA : Menu Set State hPopup, ByCmd %IDM_SortTitleA, %MFS_Checked Or %MFS_Enabled
       Case %SortGMTD   : Menu Set State hPopup, ByCmd %IDM_SortGMTD, %MFS_Checked Or %MFS_Enabled
       Case %SortTitleD : Menu Set State hPopup, ByCmd %IDM_SortTitleD, %MFS_Checked Or %MFS_Enabled
    End Select
End Sub

Sub SelectOpaqueFont
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, OpaqueFontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then OpaqueFontName = fName$ : FontSize = fSize : FontStyle = fStyle
End Sub

Sub SelectTransparencyFont
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, TransparencyFontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then TransparencyFontName = fName$ : FontSize = fSize : FontStyle = fStyle
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function MakeFont(ByVal fName As String, ByVal ptSize As Long, ByVal attr As Long) As Dword
   Local dDC As Dword, CharSet As Long, CyPixels As Long
   Local Bold, italic, uLine As Long
   If (attr And 1) Then Bold = %FW_Bold
   If (attr And 2) Then italic = 1
   If (attr And 4) Then uLine = 1
   dDC = GetDC(%HWND_Desktop)
   CyPixels  = GetDeviceCaps(dDC, %LOGPIXELSY)
   ReleaseDC %HWND_Desktop, dDC
   PtSize = 0 - (ptSize * CyPixels) \ 72
   Function = CreateFont(ptSize, 0, 0, 0, Bold, italic, uLine, _
             %FALSE, CharSet, %OUT_TT_PRECIS, _
             %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
             %FF_DONTCARE , ByCopy fName)
End Function

Function CurrentTime() As String
   Local CT As IPowerTime
   Let   CT = Class "PowerTime"
   CT.Now
   If Military Then
      Function = CT.TimeString24 + "  " + Left$(CT.DayOfWeekString,3)
   Else
      Function = CT.TimeString + "  " + Left$(CT.DayOfWeekString,3)
   End If
End Function

Sub SetDialogCaption
   If TimeInCaption Then
      Dialog Set Text hDlg, $Ver + Space$(6) + CurrentTime
   Else
      Dialog Set Text hDlg, $Ver
   End If
End Sub

Sub SetDialogBGColor
   If Transparency = 0 Then
      Dialog Set Color hDlg, BGColor, BGColor
   Else
      Dialog Set Color hDlg, %OffWhite, %OffWhite
   End If
End Sub

Sub SortLocationList
   Select Case SortMode
      Case %SortNone                : LoadLocations
      Case %SortTitleA, %SortTitleD : Array Sort D(), Call SortByTitle()
      Case %SortGMTA, %SortGMTD     : Array Sort D(), Call SortByGMT()
   End Select
   Dialog ReDraw hDlg
End Sub

Sub SizeToFitData (Flag As Long)
   Local R As SizeL, i,MaxTime,w,h As Long, buf$

   hDC = GetDC(hDlg)
   hFont = SelectObject(hDC,hFont)

   'get line height
   buf$ = "A"
   GetTextExtentPoint32 (hDC, ByVal StrPtr(buf$), Len(buf$), R)
   LineHeight = R.cy

   MaxTitle = 0
   For i = 0 To UBound(D)
      'get max title width
      buf$ = Trim$(D(i).title)
      GetTextExtentPoint32 (hDC, ByVal StrPtr(buf$), Len(buf$), R)
      MaxTitle = Max(MaxTitle,R.cx)
      'get max date/time width
      buf$ = TimeString(D(i).gmt)
      GetTextExtentPoint32 (hDC, ByVal StrPtr(buf$), Len(buf$), R)
      MaxTime = Max(MaxTime,R.cx)
   Next i

   w = g1 + ShowIcons*(16+g2) + (MaxTitle+g3) + (MaxTime+g1) + 2 * Metrics(Frame.Resize.Y)
   h = Metrics(Caption) + (UBound(D)+1)*(LineHeight+g4) + 2 * Metrics(Frame.Resize.X)

   hFont = SelectObject(hDC,hFont)
   ReleaseDC hDlg, hDC

   If Flag Then Dialog Set Size hDlg, w,h
End Sub

Sub RollupWindowAndDock
    Local x,y,w,h,wClient,hClient As Long
    Dialog Get Client hDlg To wClient, hClient
    Dialog Get Loc    hDlg To x,y
    Desktop Get Client To deskW, deskH

    If hClient < 10 Then  'MAKE LARGE - starts small, so make big and undock if required
       Docked = 0 : KillTimer hDlg, %IDC_TimerD : Dialog Set Text hDlg, $Ver
       Dialog Set Client hDlg, wPreRollup, hPreRollup
       If (x=deskW-wDock-mDock) And (y=deskH-2*mDock) Then Dialog Set Loc  hDlg, xPreRollup, yPreRollup   'restore location if not moved from docking location

       Dialog Get Loc hDlg To x,y
       Dialog Get Size hDlg To w,h
       Dialog Set Loc hDlg, IIf((x+w)>deskW, deskW-w-mDock,x), IIf((y+h)>deskH, deskH-h-mDock,y)

    Else                  'make small  - start big, so make small and dock if required
       If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
          Dialog Get Client hDlg To wPreRollup, hPreRollup
          Dialog Get Loc  hDlg To xPreRollup, yPreRollup
          Dialog Set Client hDlg, wPreRollup, 0
       End If
       If AutoDock Then
          Docked = 1
          SetTimer(hDlg, %IDC_TimerD, 250, ByVal %NULL)
          Dialog Set Client hDlg, wDock, 0
          xDock = deskW-wDock-mDock
          yDock = deskH-2*mDock - 2*AutoHideOn
          Dialog Set Loc hDlg, xDock, yDock
       End If
    End If
End Sub

Function AutoHideOn() As Long
    Local ABD As APPBARDATA
    ABD.cbSize = SizeOf(ABD)
    Function = SHAppBarMessage(%ABM_GETSTATE, ABD) And %ABS_AUTOHIDE
End Function
